package org.xtextcasts.edsl.example.edsl

import org.eclipse.emf.ecore.EAttribute
import org.eclipse.xtext.xbase.lib.Procedures.Procedure1

abstract class AbstractForm {
	@Property
	String title
	
	@Property
	val form = new GroupDef
	
	def abstract void specifyForm()
	
	def void form(String title, (GroupDef) => void proc) {
		this.title = title
		proc.apply(form)
	}
	def static group(GroupDef groupDef, String text, (GroupDef) => void proc) {
		groupDef.elementList.add(new GroupDef => [
			it.text = text
			proc.apply(it)
		])
	}

}