package org.xtextcasts.edsl.example.forms

import org.xtextcasts.edsl.example.edsl.AbstractForm

import static org.xtextcasts.edsl.example.model.ModelPackage.Literals.*

class MyForm extends AbstractForm {
	override void specifyForm() {
		// Describe form here
		 form("Registration form") [
			 group("Personal information") [
				 textInput(REGISTRATION_FORM__NAME, "Fullname:")
				 numberInput(REGISTRATION_FORM__AGE, "Age:") [ minimum = 16 ]
			 ]
			 group("Address") [
			     textInput(REGISTRATION_FORM__CITY, "City")
			     textInput(REGISTRATION_FORM__ZIP, "ZIP")
			     textInput(REGISTRATION_FORM__COUNTRY, "Country")
			 ]
		 ]
	}
}