package org.xtextcasts.edsl.example.edsl;

import java.util.ArrayList;
import org.eclipse.xtext.xbase.lib.Functions.Function0;
import org.eclipse.xtext.xbase.lib.ObjectExtensions;
import org.eclipse.xtext.xbase.lib.Procedures.Procedure1;
import org.xtextcasts.edsl.example.edsl.ElementDef;
import org.xtextcasts.edsl.example.edsl.GroupDef;

@SuppressWarnings("all")
public abstract class AbstractForm {
  private String _title;
  
  public String getTitle() {
    return this._title;
  }
  
  public void setTitle(final String title) {
    this._title = title;
  }
  
  private final GroupDef _form = new Function0<GroupDef>() {
    public GroupDef apply() {
      GroupDef _groupDef = new GroupDef();
      return _groupDef;
    }
  }.apply();
  
  public GroupDef getForm() {
    return this._form;
  }
  
  public abstract void specifyForm();
  
  public void form(final String title, final Procedure1<? super GroupDef> proc) {
    this.setTitle(title);
    GroupDef _form = this.getForm();
    proc.apply(_form);
  }
  
  public static boolean group(final GroupDef groupDef, final String text, final Procedure1<? super GroupDef> proc) {
    ArrayList<ElementDef> _elementList = groupDef.getElementList();
    GroupDef _groupDef = new GroupDef();
    final Procedure1<GroupDef> _function = new Procedure1<GroupDef>() {
        public void apply(final GroupDef it) {
          it.setText(text);
          proc.apply(it);
        }
      };
    GroupDef _doubleArrow = ObjectExtensions.<GroupDef>operator_doubleArrow(_groupDef, _function);
    boolean _add = _elementList.add(_doubleArrow);
    return _add;
  }
}
