package org.xtextcasts.edsl.example.forms;

import org.eclipse.xtext.xbase.lib.Procedures.Procedure1;
import org.xtextcasts.edsl.example.edsl.AbstractForm;
import org.xtextcasts.edsl.example.edsl.GroupDef;
import org.xtextcasts.edsl.example.edsl.NumberInputDef;
import org.xtextcasts.edsl.example.model.ModelPackage.Literals;

@SuppressWarnings("all")
public class MyForm extends AbstractForm {
  public void specifyForm() {
    final Procedure1<GroupDef> _function = new Procedure1<GroupDef>() {
        public void apply(final GroupDef it) {
          final Procedure1<GroupDef> _function = new Procedure1<GroupDef>() {
              public void apply(final GroupDef it) {
                it.textInput(Literals.REGISTRATION_FORM__NAME, "Fullname:");
                final Procedure1<NumberInputDef> _function = new Procedure1<NumberInputDef>() {
                    public void apply(final NumberInputDef it) {
                      it.setMinimum(Integer.valueOf(16));
                    }
                  };
                it.numberInput(Literals.REGISTRATION_FORM__AGE, "Age:", _function);
              }
            };
          AbstractForm.group(it, "Personal information", _function);
          final Procedure1<GroupDef> _function_1 = new Procedure1<GroupDef>() {
              public void apply(final GroupDef it) {
                it.textInput(Literals.REGISTRATION_FORM__CITY, "City");
                it.textInput(Literals.REGISTRATION_FORM__ZIP, "ZIP");
                it.textInput(Literals.REGISTRATION_FORM__COUNTRY, "Country");
              }
            };
          AbstractForm.group(it, "Address", _function_1);
        }
      };
    this.form("Registration form", _function);
  }
}
